function transformed_data = find_indices_pre(obj, data)
% FIND INDICES - runs transform_function() and looks for the indices that 
% are above TAG_THRESHOLD

    try

        %% use correct channel
        if obj.TAG_MULTIDIM_DATA_MODE_ENABLED == 1
            data_for_tagging = data(obj.TAG_MULTIDIM_USE_CHANNEL, :);
        else
            data_for_tagging = data;
        end

        %% run transform function and get crossings. output is in buffers!!
        % transformed_data = obj.transform_function(data_for_tagging);
        transformed_data = obj.scale_transform_data(data_for_tagging);

        if obj.testok == obj.PLUGIN_TEST_FAILED
            obj.TAG_QUIT = 1;
            return;
        end

    %%
    catch me
        obj.show_error(me.message, mfilename, me.stack, obj.Name, 'find_indices_pre()', me.identifier);
        obj.TAG_QUIT = 1;
    end

end
%% EOF
