function S = saveobj(obj)
% save method for fb_abstract.tag object

    % create fb_abstract.tag meta class and read out list of properties
    mc = ?fb_abstract.tag;
    tag_props = mc.Properties;

    % save top-level class name (fb_plugin_RMS, ...)
    S.ORIGINAL_PLUGIN_CLASS = class(obj);
    
    % save all TAG properties as necessary
    for i = 1 : size(tag_props, 1)
        
        this_prop = tag_props{i};
        this_prop_name = tag_props{i}.Name;
        
        % ignore Constant properties and 'event.listener' objects
        if this_prop.Constant == 1 || isa((obj.(this_prop_name)), 'event.listener') == 1
            continue;
        end
        
        % save value
        S.(this_prop_name) = obj.(this_prop_name);
        
    end
    
end
%% EOF
