function [C] = Convert_4Ch_to_2Ch(B, Length_Sync)

srate = 19200;

pnts = srate*15;    %15 seconds to calculate mean and variance, take from the middle of the record
%compute means for each full frame
NFrames = floor(Length_Sync/pnts);
Crem = rem(size(B,1),pnts);%-1;
C = B(1:(end-Crem),:);
C = reshape(C,pnts,NFrames,4);  %288000, 620, 4

Q = 0.01;   % 1% from range, about 25 steps, the midline has guaranteed accuracy of 1%
RangePlusHi = 1024+512*(1-Q); %mean is 1024, but range is from 512 to 1024+512
RangeMinusHi = 512*(1+Q);     

Cm = zeros(1,size(C,2),4);
ArrayMask = (C>RangeMinusHi)&(C<RangePlusHi);
for I_t = 1:size(ArrayMask,2)
  for J_t = 1:4  
    Cm(1,I_t,J_t) = mean(C(ArrayMask(:,I_t,J_t),I_t,J_t)); %was mean before 28.02.2014, but median does not help
  end
end    %4.2 seconds
Cmm = repmat(Cm,size(C,1),1);
Q1 = 0.10;  %10 percent out, tried 5%, but did not help in one case, 1% good for 2013-12-11playback!!!
ArrayMask1 = (C>Cmm+Q1*512)|(C<Cmm-Q1*512);
ArrayMask2 = ArrayMask & ArrayMask1;

C_minus_mean = C-Cmm;
clear Cmm

Sums = zeros(size(C,2),4); %620x4
for K_t = 1:size(C,2)   %was par
  MySum = zeros(1,4);
  P_minus_mean0 = squeeze(C_minus_mean(:,K_t,:));
for I_t = 1:size(C,1)    
  P_minus_mean = P_minus_mean0(I_t,:);
  if ArrayMask2(I_t,K_t,1)
    MySum(1,[1 2]) = MySum(1,[1 2])+abs(P_minus_mean([1 2]));
  end
  if ArrayMask2(I_t,K_t,3)
    MySum(1,[3 4]) = MySum(1,[3 4])+abs(P_minus_mean([3 4]));
  end     
end
Sums(K_t,:) = MySum(1,:) ;
end
clear ArrayMask ArrayMask1 ArrayMask2 C_minus_mean P_minus_mean0

K = Sums(:,[1 3])./Sums(:,[2 4]);
B_minus_mean = B;
for I_t = 1:size(C,2)
  L = pnts*(I_t-1)+(1:pnts);
    B_minus_mean(L,2) = (B(L,2)-Cm(1,I_t,2))*K(I_t,1)+Cm(1,I_t,1);
    B_minus_mean(L,4) = (B(L,4)-Cm(1,I_t,4))*K(I_t,2)+Cm(1,I_t,3);
end
clear L
%correct the tail
if (Crem>-1)
  L = (pnts*size(C,2)+1):size(B,1);
    B_minus_mean(L,2) = (B(L,2)-Cm(1,end,2))*K(end,1)+Cm(1,end,1);
    B_minus_mean(L,4) = (B(L,4)-Cm(1,end,4))*K(end,2)+Cm(1,end,3);
end;
clear L Cm
%%
%combine two records replacing cutted values by low-resolution values
P = B(:,1);
V = (P<=RangeMinusHi)|(P>=RangePlusHi);
B_minus_mean(V,1) = B_minus_mean(V,2);
P = B(:,3);
V = (P<=RangeMinusHi)|(P>=RangePlusHi);
B_minus_mean(V,3) = B_minus_mean(V,4);
clear P V B %temporarily removed delete
C = B_minus_mean(:,[1 3]);  %here we have mean about 512(?)!!!
%clear B_minus_mean P_minus_mean

