function [ LastNZCount Shift ] = GetEndShift( NI,BP,Param )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

NFiles = 2;
SyncA = cell(NFiles,1);
SyncA{1} = NI.Sync;
SyncA{2} = BP.Sync;
MyStarts = [NI.Start_count BP.Start_count];
%get length
clear L LS
L = [length(NI.Sync) length(BP.Sync)]; 
LS = L-MyStarts+1;
[minLS ShortestRecID] = min(LS);

%get last non-zero count in the shortest record (BP)
LastNZCount = length(SyncA{ShortestRecID})-Param.MaxShiftAllowedEnd;    %need some reserve to shift forwards
while SyncA{ShortestRecID}(LastNZCount)==0
  LastNZCount = LastNZCount-1;  
end 
LastNZCount = LastNZCount-MyStarts(ShortestRecID);

NGPUs = gpuDeviceCount;
if NGPUs<Param.MyGPU
  setGPU = NGPUs; 
else
  setGPU = Param.MyGPU;  
end 
if setGPU>0
  gpuDevice(setGPU);
  GPU = true;
else
  GPU = false;  
end    
%tic
A_short = SyncA{Param.BestAnimal}(MyStarts(Param.BestAnimal)+LastNZCount-((Param.SynchronizationFrame-1):-1:0));
for I_t = 1:NFiles
  if I_t~=Param.BestAnimal  
    A_long =SyncA{I_t}(MyStarts(I_t)+LastNZCount...
        -((Param.SynchronizationFrame+Param.MaxShiftAllowedEnd):-1:-Param.MaxShiftAllowedEnd));
  end
end
Shift = GetShiftsG(A_short,A_long,GPU)-Param.MaxShiftAllowedEnd;  
disp(['Last vocalization time: ' num2str(LastNZCount/Param.scanrateMax/60/60) ' h']);
disp(['Shift from the "best animal"(NI): ' num2str(Shift/Param.scanrateMax) ' s']);
%toc

MyColor = {'r','b','g','m','k','c'};
scrsz = get(0,'ScreenSize');

hf = figure(1);clf;
set(hf,'Position',round([1 scrsz(4)*2/3-35 scrsz(3) scrsz(4)/3-35]));

X = (-round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed):round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed))/Param.scanrateMax;
subplot(2,1,1);
hold on
for I_t = 1:NFiles
  MyMin = MyStarts(I_t)-round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed);
  MyMax = MyStarts(I_t)+round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed);
  if MyMin<1  
    X1 = (1-MyMin-round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed):...
        round(Param.SynchronizationFrame/2+Param.MaxShiftAllowed))/Param.scanrateMax;
    MyMin = 1;
  else
    X1 = X;
  end    
  A = SyncA{I_t}(MyMin:MyMax);
  ha(I_t) = plot(X1,double(A)*0.9+(I_t-1),MyColor{I_t});
end
hold off
xlim([X(1),X(end)]);
ylim([0 NFiles]);
line(-round(Param.SynchronizationFrame/2)/Param.scanrateMax*[1 1],[0 NFiles],'Color','k','LineStyle',':');
line(0/Param.scanrateMax*[1 1],[0 NFiles],'Color','k','LineStyle',':');
line(round(Param.SynchronizationFrame/2)/Param.scanrateMax*[1 1],[0 NFiles],'Color','k','LineStyle',':');
xlabel('Time, s');
title([Param.Name ': Record start (synchro)'],'Interpreter','none');
h = legend(ha,'NI recorder','Backpack'); 
set(h,'box','off');
box on

X = (LastNZCount-MyStarts(1)-((Param.SynchronizationFrame+Param.MaxShiftAllowedEnd):-1:-Param.MaxShiftAllowedEnd))/Param.scanrateMax;
subplot(2,1,2);
hold on
for I_t = 1:NFiles
  A = SyncA{I_t}(LastNZCount+MyStarts(I_t)-((Param.SynchronizationFrame+Param.MaxShiftAllowedEnd):-1:-Param.MaxShiftAllowedEnd));
  plot(X,double(A)*0.9+(I_t-1),MyColor{I_t});
end
hold off
xlim([X(1),X(end)]);
ylim([0 NFiles]);
line((LastNZCount-Param.MaxShiftAllowedEnd)/Param.scanrateMax*[1 1],[0 NFiles],'Color','k','LineStyle',':');
line((LastNZCount-Param.MaxShiftAllowedEnd-Param.SynchronizationFrame)/Param.scanrateMax*[1 1],[0 NFiles],'Color','k','LineStyle',':');
xlabel('Time, s');
title('Record end (not aligned)');
box on

NameTmp = [Param.StartDir filesep Param.Name '_EndShift'];
%saveas(hf,NameTmp,'fig'); 
saveas(hf,NameTmp,'emf');

end

